/******************************************************************************
 * JWebUnit project (http://jwebunit.sourceforge.net)                         *
 * Distributed open-source, see full license under LICENCE.txt                *
 ******************************************************************************/
package net.sourceforge.jwebunit.tests;

import junit.framework.Test;
import junit.framework.TestSuite;
import net.sourceforge.jwebunit.tests.util.JettySetup;

/**
 * Sanity check for the Jetty setup.
 * 
 * @author Martijn Dashorst
 */
public class HelloWorldTest extends JWebUnitAPITestCase {
	public HelloWorldTest(String name) {
		super(name);
	}

	public static Test suite() {
		return new JettySetup(new TestSuite(HelloWorldTest.class));
	}

	public void setUp() throws Exception {
		super.setUp();
		setBaseUrl(HOST_PATH);
		beginAt("/helloworld.html");
	}

	public void testTitle() {
		assertTitleEquals("Hello, World!");
		assertTitleNotSame("Goodbye, World!");
	}

}